#!@l_bash@
##
##  jira-setup.sh -- Jira RDBMS Setup Utility
##

#   command line argument sanity check
prg="$0"
if [ $# -eq 0 ]; then
    echo "$prg:ERROR: invalid command line" 1>&2
    echo "$prg:USAGE: $prg install [<database-directory>]" 1>&2
    echo "$prg:USAGE: $prg uninstall" 1>&2
    exit 1
fi

#   database configuration
db_dir="@l_prefix@/var/jira/db"
db_type="@l_dbtype@"
db_name="jira"
db_user="jira"
db_pass="jira"

#   determine RDBMS-specific details
if [ ".$db_type" = .mysql ]; then
    db_sname="mysql"
    db_suser=`grep "^user" @l_prefix@/etc/mysql/my.pwd |\
              sed -e 's;^user[^=]*= *;;' -e 's; *$;;'`
    db_spass=`grep "^password" @l_prefix@/etc/mysql/my.pwd |\
              sed -e 's;^password[^=]*= *;;' -e 's; *$;;'`
elif [ ".$db_type" = .pgsql ]; then
    db_sname=`grep "^superuser_database" @l_prefix@/var/postgresql/db/pg_superuser.conf |\
              sed -e 's;^ *superuser_database="\(.*\)".*;\1;'`
    db_suser=`grep "^superuser_username" @l_prefix@/var/postgresql/db/pg_superuser.conf |\
              sed -e 's;^ *superuser_username="\(.*\)".*;\1;'`
    db_spass=`grep "^superuser_password" @l_prefix@/var/postgresql/db/pg_superuser.conf |\
              sed -e 's;^ *superuser_password="\(.*\)".*;\1;'`
fi

#   dispatch operation
cmd="${1:-"install"}"
shift
case "$cmd" in
    install )
        ##
        ##  create the database
        ##

        if [ $# -gt 0 ]; then
            db_dir="$1"
            shift
        fi
        if [ ".$db_type" = .mysql ]; then
            #   FIXME: MySQL 5.0 still doesn't allow easy relocation of tablespaces
            ( echo "CREATE DATABASE $db_name CHARACTER SET 'utf8' COLLATE 'utf8_bin';"
              echo "GRANT ALL PRIVILEGES ON $db_name.* TO $db_user@localhost IDENTIFIED BY '$db_pass';"
              echo "FLUSH PRIVILEGES;"
            ) | @l_prefix@/bin/mysql --user="$db_suser" --password="$db_spass" "$db_sname"
        elif [ ".$db_type" = .pgsql ]; then
            ( echo "CREATE ROLE $db_user LOGIN ENCRYPTED PASSWORD '$db_pass' NOCREATEDB NOCREATEROLE;"
              echo "CREATE TABLESPACE $db_name OWNER $db_user LOCATION '$db_dir';"
              echo "CREATE DATABASE $db_name OWNER $db_user TABLESPACE $db_name ENCODING 'UTF8';"
            ) | PGPASSWORD="$db_spass" @l_prefix@/bin/psql -q -U "$db_suser" -d "$db_sname" -f-
        fi
        ;;

    uninstall )
        ##
        ##  remove the database
        ##

        if [ ".$db_type" = .mysql ]; then
            ( echo "DROP DATABASE $db_name;"
              echo "DROP USER $db_user@localhost;"
            ) | @l_prefix@/bin/mysql --user="$db_suser" --password="$db_spass" "$db_sname"
        elif [ ".$db_type" = .pgsql ]; then
            ( echo "DROP DATABASE $db_name;"
              echo "DROP TABLESPACE $db_name;"
              echo "DROP ROLE $db_user;"
            ) | PGPASSWORD="$db_spass" @l_prefix@/bin/psql -q -U "$db_suser" -d "$db_sname" -f-
        fi
        ;;
esac

